var AWS = require("aws-sdk");

var region = "<[W>";

AWS.config.update({
  region: region,
  endpoint: "https://dynamodb." + region + ".amazonaws.com"
});

var dynamodb = new AWS.DynamoDB();

var params = {
    TableName : "Notes",
    KeySchema: [       
        { AttributeName: "user_id", KeyType: "HASH"},
        { AttributeName: "date_time", KeyType: "RANGE" }
    ],
    AttributeDefinitions: [       
        { AttributeName: "user_id", AttributeType: "S" },
        { AttributeName: "date_time", AttributeType: "S" }
    ],
    ProvisionedThroughput: {       
        ReadCapacityUnits: 10, 
        WriteCapacityUnits: 10
    }
};

dynamodb.createTable(params, function(err, data) {
    if (err) {
        console.error("Unable to create table. Error JSON:", JSON.stringify(err, null, 2));
    } else {
        console.log("Created table. Table description JSON:", JSON.stringify(data, null, 2));
    }
});
