function Cognito() {
	var m_roleArn = '<Role ARN>';
	var m_identityPoolId = '<cognito identity pool id>';
	var m_unauthUserId = null;
	var m_logInCallback = null;
	var m_logOutCallback = null;
	
	this.init = function(logInCallback, logOutCallback) {
		m_logInCallback = logInCallback;
		m_logOutCallback = logOutCallback;
	};
	
	this.setUnauthUserId = function(userId) {
		m_unauthUserId = userId;
		console.log('set unauthUserId=' + m_unauthUserId);
	};
	
	this.logIn = function(credential) {
		var params = {
			IdentityPoolId: m_identityPoolId,
			RoleArn: m_roleArn,
			Logins: {
				'graph.facebook.com': credential.accessToken
			}
		};
		AWS.config.credentials = new AWS.CognitoIdentityCredentials(params);

		AWS.config.credentials.clearCachedId();	// これがないと、ユーザー切り替え時に。get が失敗する。
		// Obtain AWS credentials
		AWS.config.credentials.get(function(err){
			if (err) {
				console.log("credentials.get error:" + err);
				if (m_logInCallback) {
					m_logInCallback(false, "credentials.get error code:\n" + JSON.stringify(err, null, 2));
				}
			} else {
				console.log("Cognito Identity Id: " + AWS.config.credentials.identityId);
				if (m_logInCallback) {
					m_logInCallback(true, AWS.config.credentials.identityId);
				}
			}
		});
	};
	
	this.logOut = function() {
		if (m_unauthUserId !== null) {
			var params = {
				IdentityPoolId: m_identityPoolId,
				RoleArn: m_roleArn,
				IdentityId: m_unauthUserId
			};
			AWS.config.credentials = new AWS.CognitoIdentityCredentials(params);

			// Obtain AWS credentials
			AWS.config.credentials.get(function(err){
				if (err) {
					console.log("credentials.get error:" + err);
					if (m_logOutCallback) {
						m_logOutCallback(false, "credentials.get error code:\n" + JSON.stringify(err, null, 2));
					}
				} else {
					console.log("Unauthenticated Cognito Identity Id: " + AWS.config.credentials.identityId);
					if (m_logOutCallback) {
						m_logOutCallback(true, AWS.config.credentials.identityId);
					}
				}
			});
		} else {
			var params = {
				IdentityPoolId: m_identityPoolId,
				RoleArn: m_roleArn
			};
			AWS.config.credentials = new AWS.CognitoIdentityCredentials(params);

			AWS.config.credentials.clearCachedId();	// これがないと、ユーザー切り替え時に。get が失敗する。
			// Obtain AWS credentials
			AWS.config.credentials.get(function(err){
				if (err) {
					console.log("credentials.get error:" + err);
					if (m_logOutCallback) {
						m_logOutCallback(false, "credentials.get error code:\n" + JSON.stringify(err, null, 2));
					}
				} else {
					console.log("Unauthenticated Cognito Identity Id: " + AWS.config.credentials.identityId);
					if (m_logOutCallback) {
						m_logOutCallback(true, AWS.config.credentials.identityId);
					}
				}
			});
		}
	};
}
