function DbControllerClientCognito() {

	var m_dynamoDB = null;
	var m_dynamodbDoc = null;
	var region = "<リージョン名>";
	var endpoint = "https://dynamodb." + region + ".amazonaws.com";
	var table = "Notes";

	this.init = function() {
	};

	this.open = function() {
		if (m_dynamoDB === null) {
			console.log('open');
			m_dynamoDB = new AWS.DynamoDB();
			m_dynamoDB.config.update({
			  region: region,
			  endpoint: endpoint
			});
			m_dynamodbDoc = new AWS.DynamoDB.DocumentClient({service:m_dynamoDB});
		}
	};
	
	this.close = function() {
		console.log('close');
		m_dynamoDB = null;
		m_dynamodbDoc = null;
	};
	
	this.getNoteList = function(userId, callback) {
		console.log("userId", userId);
		var params = {
			TableName : table,
			KeyConditionExpression: "user_id = :userId",
			ExpressionAttributeValues: {
				":userId": userId
			}
		};
		console.log("query param ", JSON.stringify(params));
		m_dynamodbDoc.query(params, function(err, data) {
			if (err) {
				var msg = JSON.stringify(err, null, 2);
				console.log("Unable to query. Error:", msg);
				callback(false, null, "faild to qurey:\n" + msg);
			} else {
				var notes = new Array();
				console.log("Query succeeded.");
				var itemSize = data.Items.length;
				if (itemSize == 0) {
					callback(true, "new", notes);
				} else {
					var replyCount = 0;
					data.Items.forEach(function(item) {
						replyCount++;
						console.log(" -", JSON.stringify(item));
						var note = {
							user_id : item.user_id,
							date_time : item.date_time,
							text : item.text
						};
						notes.push(note);
						if (replyCount >= itemSize) {
							callback(true, "new", notes);
						}
					});
				}
			}
		});
	};

	this.sendNote = function(userId, text, editKey, callback) {
		var params = {
			TableName : table,
			Item : {
				user_id : userId,
				text : text
			}
		};
		var operation;
		if (editKey !== null) {
			params.Item.date_time = editKey;
			operation = 'update';
		} else {
			var now = new Date();
			params.Item.date_time = Util.date2str(now);
			operation = 'add';
		}
		
		console.log("Adding a new item...", JSON.stringify(params));
		m_dynamodbDoc.put(params, function(err, data) {
		    if (err) {
		        console.error("Unable to add item. Error JSON:", JSON.stringify(err, null, 2));
				callback(false, null, null);
			    return;
		    } else {
		        console.log("Added item:", JSON.stringify(data, null, 2));
			    var updatedList = [];
				callback(true, operation, params.Item);
			}
		});
	};

	this.clearAllNote = function(userId, callback) {
		var params = {
			TableName : table,
			KeyConditionExpression: "user_id = :userId",
			ExpressionAttributeValues: {
				":userId": userId
			}
		};
		console.log("query param ", JSON.stringify(params));
		m_dynamodbDoc.query(params, function(err, data) {
			var notes = new Array();
			if (err) {
				console.log("Unable to query. Error:", JSON.stringify(err, null, 2));
				callback(false, null, null);
			} else {
				console.log("Query succeeded.");
				deleteItems(data.Items, function(isSuccess, param1, param2) {
					callback(isSuccess, param1, null);
				});
			}
		});
	};

	function deleteItems(items, callback) {
		params = {
			RequestItems: {}
		};
		var deletedItems = [];
		params.RequestItems[table] = [];
		console.log("test ", JSON.stringify(params));
		items.forEach(function(item) {
			console.log(" -", JSON.stringify(item));
			var request = {
				DeleteRequest : {
					Key: {
						user_id: item.user_id,
						date_time : item.date_time
					}
				}
			};
			params.RequestItems[table].push(request);
			deletedItems.push({
				user_id: item.user_id,
				date_time : item.date_time
			});
		});
		console.log("delete req:", JSON.stringify(params));
		m_dynamodbDoc.batchWrite(params, function(err, data) {
			if (err) {
				console.log("Unable to batchWrite. Error:", JSON.stringify(err, null, 2));
				callback(false, null, null);
			} else {
				console.log("batchWriteItem succeeded.");
				callback(true, "delete", deletedItems);
			}
		});
	}
	
	this.deleteNote = function(userId, keyDateTime, callback) {
		var dataList= [];
		dataList.push({user_id : userId, date_time : keyDateTime});
		deleteItems(dataList, function(isSuccess, param1, param2) {
			if (isSuccess) {
				callback(isSuccess, param1, param2[0]);
			} else {
				callback(isSuccess, param1, param2);
			}
		});
	};
}
