var _s_myNoteView = null;

function MyNoteView() {
	var m_doc = null;

	this.init = function (doc) {
		m_doc = doc;
		m_doc.setView(this);
		_s_myNoteView = this;
	};
	
	this.clearNote = function() {
		$("#note_list").empty();
	};
	
	this.addNote = function(userId, index) {
		var content = layoutNote(userId, index);
		$("#note_list").append(content);
		var note = getNote(index);
		var p = $('#note_' + note.no).offset().top;
		$('#detail_area').animate({scrollTop:p}, 'fast');
	};
	
	this.updateNote = function(userId, index) {
		var content = layoutNote(userId, index);
		var noteList = m_doc.getNoteList();
		$("#" + noteList[index].name).replaceWith(content);
		var note = getNote(index);
		var p = $('#note_' + note.no).offset().top;
		$('#detail_area').animate({scrollTop:p}, 'fast');
	};
	
	this.removeNote = function(note) {
		$("#" + note.name).remove();
	};
	
	function getNote(index) {
		var noteList = m_doc.getNoteList();
		return noteList[index];
	}
	
	function layoutNote(userId, index) {
		var text = '';
		var note = getNote(index);
		var dateTime = Util.str2date(note.data.date_time);
		var content ='<div id="note_' + note.no + '" class="note_content">';

		content += '<div class="note_button">';
		content += '<div id="edit_' + note.no + '" class="img_button" onClick="_s_myNoteView.onEdit(this);"><img src="image/edit.png"></div>';
		content += '<div id="garbage_' + note.no + '" class="img_button" onClick="_s_myNoteView.onGarbage(this);"><img src="image/garbage.png"></div>';
		content += '</div>';	// note_button
		content += '<div class="note_date">' +	 dateTime.toLocaleString() + '</div>';

		var note_text = note.data.text;
		note_text = Util.Sanitaize.encode(note_text);
		note_text = Util.cr2br(note_text);
		note.textForDisplay = note_text;
		content += '<div class="note_text">' + note_text + '</div>'

		content += '<div class="sep"></div>';
		content += '</div>';	// note_content
		return content;
	}

	this.onEdit = function(element) {
		console.log('onEdit id:' + element.id);
		var elms = element.id.split('_');
		if (elms.length <= 0) {
			console.log("can not parse : " + element.id);
			return;
		}
		var name = 'note_' + elms[elms.length - 1];
		var textVal = '';
		var noteList = m_doc.getNoteList();
		var index;
		for (index = 0; index < noteList.length; index++) {
			if (noteList[index].name == name) {
				textVal = noteList[index].data.text;
				break;
			}
		}
		if (textVal =='') {
			console.log("can not find key: " + name);
			return;
		}
		console.log('onEdit:' + name + ' index=' + index + ' text=' + textVal);
		m_doc.setEditIndex(index);
		$("#plane_text_area").val(textVal);
	};
	
	this.onGarbage = function(element) {
		console.log('onGarbage id:' + element.id);
		var elms = element.id.split('_');
		if (elms.length <= 0) {
			console.log("can not parse : " + element.id);
			return;
		}
		var name = 'note_' + elms[elms.length - 1];
		var noteList = m_doc.getNoteList();
		var index;
		for (index = 0; index < noteList.length; index++) {
			if (noteList[index].name == name) {
				m_doc.deleteNote(index);
				return;
			}
		}
		console.log("not found : " + name);
	};
	
	this.updateInfo = function() {
		var text = "";
		if (m_doc != null) {
			text += 'User ID: ' + Util.Sanitaize.encode(m_doc.getUserId());
		}
		$("#info").html(text);
	};
}
