var Util = {
	Sanitaize : {
		encode : function (str) {
			if (!str) {
				return str;
			}
			return str.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g, '&#39;');
		},
	
		decode : function (str) {
			if (!str) {
				return str;
			}
			return str.replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"').replace(/&#39;/g, '\'').replace(/&amp;/g, '&');
		}
	},

	cr2br : function (str) {
		if (!str) {
			return str;
		}
		return str.replace(/[\n\r]/g, "<br/>");
	},

	zeroPadding : function (val, length) {
		var pad = '';
		if (length > 4) {
			for (var i = 0; i < length; i++) {
				pad += '0';
			}
		} else {
			pad = '0000';
		}
		return (pad + val).slice(-length);
	},

	date2str : function(date) {
		var text = Util.zeroPadding(date.getUTCFullYear(), 4) + '.' +
			Util.zeroPadding(date.getUTCMonth()+1, 2) + '.' +
			Util.zeroPadding(date.getUTCDate(), 2) + '.' +
			Util.zeroPadding(date.getUTCHours(), 2) + '.' +
			Util.zeroPadding(date.getUTCMinutes(), 2) + '.' +
			Util.zeroPadding(date.getUTCSeconds(), 2);
		return text;
	},

	str2date : function(text) {
		try {
			var year  = Number(text.slice(0, 4));
			var month = Number(text.slice(5, 7)) - 1;
			var date   = Number(text.slice(8, 10));
			var hours = Number(text.slice(11, 13));
			var minutes = Number(text.slice(14, 16));
			var seconds = Number(text.slice(17, 19));
			var d = new Date(Date.UTC(year, month, date, hours, minutes, seconds, 0));
			return d;
		} catch (e) {
			console.log(e);
			return new Date(0);
		}
	}
};
